/*
 * Created on 2005/01/25
 *
 * @author KAMO Masahiko (mkamo@users.sourceforge.jp)
 */
package razgriz.news.ui.actions;

import java.util.Iterator;
import java.util.List;

import org.eclipse.jface.action.Action;
import org.eclipse.jface.viewers.IStructuredSelection;
import org.eclipse.jface.viewers.Viewer;
import org.eclipse.ui.IWorkbenchSite;

import razgriz.news.model.Article;
import razgriz.news.model.ModelElement;
import razgriz.news.model.News;
import razgriz.news.visitor.MarkAsReadVisitor;

/**
 * 
 */
public class MarkAsReadAllAction extends Action {
    public static final String ID = MarkAsReadAllAction.class.getName();

    IWorkbenchSite site;
    Viewer viewer;
    
    public MarkAsReadAllAction(IWorkbenchSite site, Viewer viewer) {
        super();

        this.site = site;
        this.viewer = viewer;

        setId(ID);
        setText("ׂĊ");
        setToolTipText("ׂĂ̋Lǂɂ܂");
        setImageDescriptor(null);
    }

    public void run() {
        IStructuredSelection sel =
            (IStructuredSelection) viewer.getSelection();

        for (Iterator ite = sel.iterator(); ite.hasNext(); ) {
            Object obj = ite.next();
            if (obj instanceof Article) {
                News news = ((Article) obj).getNews();
                List artlist = news.getArticles();
                viewer.getControl().setRedraw(false);
                try {
                    for (int i = 0; i < artlist.size(); i++) {
                        ((Article) artlist.get(i)).setRead(true);
                    }
                } finally {
                    viewer.getControl().setRedraw(true);
                }
            } else {
                ModelElement elem = (ModelElement) obj;
                elem.accept(new MarkAsReadVisitor());
            }
        }
    }
}
